/***************************************************************************/
/**                                                                       **/
/**              MODULAR-4 library for SPB module M-DPS-12                **/
/**                                                                       **/
/**                             Version 1.B. (19.01.1998)                 **/
/**                                                                       **/
/**  Changes: The address of m045_data_in_out may be defined in           **/
/**           m045_bib_startup                                            **/
/**                             Version 1.A.                              **/
/**                                                                       **/
/**  This file contains routines for Borland C++/3.1 to allow the user,   **/
/**  to write programs for the MODULAR-4 in "C"                           **/
/**                                                                       **/
/**             Last change      : 16.01.1997                             **/
/**                                                                       **/
/**                         Author : H.K.                                 **/
/**                         Status : O.K.				  **/
/**                                                                       **/
/** This library was tested with Borland C++ Version 3.1.                 **/
/**                                                                       **/
/**               (c) SORCUS Computer GmbH 1996                           **/
/**                                                                       **/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/

/* The switches for the library are set in the configuration files of Pascal
   (*.TP file) und C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
   to be included.
*/

#ifdef ML8RT
/* As the parameters micro_slot und offset have changed in the function
   ml8rt_read_eeprom, using ml8rtbib version 1.C. and less the instruction
   #define ML8RT_VERSION_1C has to be added
*/
#endif

#ifdef BORLAND_PASCAL

       #define STATIC static           /* for Definition of arrays         */

#else
       #define STATIC static far       /* for Definition of arrays         */

#endif

#ifndef ML8RT
       #include "ML8BIB.H"

				       /* The functions of library ML8BIB  */
				       /* all begin with ml8_... :         */
       #define mlx_read_eeprom            ml8_read_eeprom_copy
       #define mlx_out8_port              ml8_out8_port
       #define mlx_out16_port             ml8_out16_port
       #define mlx_in8_port               ml8_in8_port
       #define mlx_in16_port              ml8_in16_port
#else
       #include "stdio.h"
       #include "dos.h"
       #include "ML8RTBIB.H"

       #define mlx_out8_port(port, dat1)  outportb(port, dat1)
       #define mlx_out16_port(port, dat1) outport(port, dat1)
       #define mlx_in8_port(port)         inportb(port)
       #define mlx_in16_port(port)        inport(port)
#endif


#ifdef ML8RT
       #ifdef ML8RT_VERSION_1C
	      #define mlx_read_eeprom(micro_slot, offset) ml8rt_read_eeprom_copy(offset, micro_slot)
       #else
	      #define mlx_read_eeprom(micro_slot, offset) ml8rt_read_eeprom_copy(micro_slot, offset)
       #endif
#endif

#define ushort unsigned short

#ifdef _Windows                         /* if module DLL shall be generated */

#include <windows.h>

HANDLE   hInst;

#pragma argsused

int far pascal LibMain(hInstance, wDataSeg, wHeapSize, lpszCmdLine)
HANDLE  hInstance;                     /* Instance of DLL                  */
WORD    wDataSeg;                      /* Data segment                     */
WORD    wHeapSize;                     /* Size of Heap                     */
LPSTR   lpszCmdLine;                   /* Pointer to command line          */

{
 hInst = hInstance;
 if(wHeapSize > 0) UnlockData(0);
 return(1);
}

#endif  /* _Windows */

#include "m045_lib.h"

#ifndef BORLAND_PASCAL

/* Number of task, under which program M8P0332 is installed
*/
ushort tasknum = M045_TASK;

#else
/* Number of task, under which program M8P0332 is installed
*/
extern far pascal ushort tasknum;

#endif

#include <stdlib.h>


void EXPORT m045_bib_startup(byte microslot, byte channel)
{
 byte   	 inarr = 0;
 func_10_in_type outarr;

#ifndef ML8RT                      /* ml8x_call_func parameters */
 ushort outsize = 0,
 insize  = 0;
 byte   err 	= 0;
#else
 unsigned int outsize = 0,
	      insize  = 0,
	      err     = 0;

 asm pushf                         /* Disable CPU-Interrupt */
 asm cli
#endif

 outsize                          = sizeof(outarr);
 outarr.microslot 		  = microslot;
 outarr.channel   		  = channel;
#ifndef ML8RT
 ml8_call_func(tasknum,M045_BIB_START_PROC,
	       outsize,&outarr,insize,&insize,&inarr,&err);
#else
 outarr.m045_diag_buffer_changed  = m045_diag_buffer_changed;
 outarr.m045_check_parameter 	  = m045_check_parameter;
 outarr.m045_check_config 	  = m045_check_config;
 outarr.m045_offline   	  	  = m045_offline;
 outarr.m045_global_ctrl_command  = m045_global_ctrl_command;
 outarr.m045_go_leave_data_ex 	  = m045_go_leave_data_ex;
 outarr.m045_wd_timeout	  	  = m045_wd_timeout;
 outarr.m045_new_ssa_data 	  = m045_new_ssa_data;
 outarr.m045_user_timer_clock 	  = m045_user_timer_clock;
 outarr.m045_baudrate_detect 	  = m045_baudrate_detect;
 outarr.m045_error_function 	  = m045_error_function;
 outarr.m045_data_in_out        = m045_data_in_out;
 ml8rt_call_func(tasknum,M045_BIB_START_PROC,
		 &outsize,&outarr,insize,&insize,&inarr,&err);
 asm popf
#endif
}

#pragma argsused

void EXPORT m045_init(byte 	    microslot,
		      byte 	    channel,
		      byte 	    irq_num,
		      m_dps_12_type m_dps_12)
{
 byte 		 inarr = 0;
 ushort 	 i     = 0;
 func_11_in_type outarr;

#ifndef ML8RT                      /* ml8x_call_func parameters */
 ushort outsize = 0,
	insize  = 0;
 byte 	err 	= 0;
#else
 unsigned int outsize = 0,
	      insize  = 0,
	      err     = 0;

 asm pushf                         /* Disable CPU-Interrupt */
 asm cli
#endif

 outsize                          	  = sizeof(outarr);
 outarr.microslot 		  	           = microslot;
 outarr.channel   		  	           = channel;
 outarr.irq_num   		              = irq_num;
 outarr.m_dps_12.indication 		     = m_dps_12.indication;
 outarr.m_dps_12.user_wd_val 		     = m_dps_12.user_wd_val;
 outarr.m_dps_12.this_station 		  = m_dps_12.this_station;
 outarr.m_dps_12.ident_num 		     = m_dps_12.ident_num;
 outarr.m_dps_12.change_station_number	  = m_dps_12.change_station_number;
 outarr.m_dps_12.hw_mode 		           = m_dps_12.hw_mode;
 outarr.m_dps_12.mintsdr 		           = m_dps_12.mintsdr;
 outarr.m_dps_12.cfg_len_akt		        = m_dps_12.cfg_len_akt;
 for (i=0;i<m_dps_12.cfg_len_akt;i++)
   outarr.m_dps_12.cfg_akt[i] 		  = m_dps_12.cfg_akt[i];
 outarr.m_dps_12.dps2_buf.din_dout_buf_len= m_dps_12.dps2_buf.din_dout_buf_len;
 outarr.m_dps_12.dps2_buf.diag_buf_len    = m_dps_12.dps2_buf.diag_buf_len;              /* length of diagnosisbuffer 6-244  */
 outarr.m_dps_12.dps2_buf.prm_buf_len 	  = m_dps_12.dps2_buf.prm_buf_len;               /* length of parameterbuffer 7-244  */
 outarr.m_dps_12.dps2_buf.cfg_buf_len 	  = m_dps_12.dps2_buf.cfg_buf_len;               /* length of config-databuf. 1-244  */
 outarr.m_dps_12.dps2_buf.ssa_buf_len     = m_dps_12.dps2_buf.ssa_buf_len;               /* length of set-slave-addr.-buf.   */

#ifndef ML8RT
 ml8_call_func(tasknum,M045_INIT_PROC,
	       outsize,&outarr,insize,&insize,&inarr,&err);
#else
 outarr.m_dps_12.i_data			  = m_dps_12.i_data;

 ml8rt_call_func(tasknum,M045_INIT_PROC,
		 &outsize,&outarr,insize,&insize,&inarr,&err);
 asm popf
#endif
}

void EXPORT m045_read_data(byte microslot, byte channel, ushort *count, byte *flag, byte *i_data)
{
 ushort 	  i = 0;
 func_12_in_type  outarr;
 func_12_out_type inarr;

#ifndef ML8RT			   /* ml8x_call_func parameters */
 ushort outsize = 0,
	insize  = 0;
 byte 	err 	= 0;
#else
 unsigned int outsize = 0,
	      insize  = 0,
	      err     = 0;

 asm pushf                         /* Disable CPU-Interrupt */
 asm cli
#endif

 outsize                          = sizeof(outarr);
 insize				  = sizeof(inarr);
 inarr.count			  = *count;
 outarr.microslot 		  = microslot;
 outarr.channel   		  = channel;
 outarr.offset			  = 0;
#ifdef ML8RT
 ml8rt_call_func(tasknum,M045_READ_DATA_AVAIL_PROC,
		 &outsize,&outarr,insize,&insize,&inarr,&err);
#else
 ml8_call_func(tasknum,M045_READ_DATA_AVAIL_PROC,
	       outsize,&outarr,insize,&insize,&inarr,&err);
#endif
 *flag = 0;
 if (inarr.flag == 1) {
   *count = inarr.count;
   *flag = 1;
   for (i= 0; i < inarr.count;i++)
     i_data[i] = inarr.data[i];
   }
#ifdef ML8RT
 asm popf
#endif
}

void EXPORT m045_read_data_direct(byte microslot, byte channel, ushort *count, byte *i_data, byte offset)
{
 ushort 	  i = 0;
 func_12_in_type  outarr;
 func_12_out_type inarr;

#ifndef ML8RT			   /* ml8x_call_func parameters */
 ushort outsize = 0,
	insize  = 0;
 byte 	err 	= 0;
#else
 unsigned int outsize = 0,
	      insize  = 0,
	      err     = 0;

 asm pushf                         /* Disable CPU-Interrupt */
 asm cli
#endif

 outsize                          = sizeof(outarr);
 insize				  = sizeof(inarr);
 inarr.count			  = *count;
 outarr.microslot 		  = microslot;
 outarr.channel   		  = channel;
 outarr.offset			  = offset;
#ifdef ML8RT
 ml8rt_call_func(tasknum,M045_READ_DATA_DIRECT_PROC,
		 &outsize,&outarr,insize,&insize,&inarr,&err);
#else
 ml8_call_func(tasknum,M045_READ_DATA_DIRECT_PROC,
	       outsize,&outarr,insize,&insize,&inarr,&err);
#endif
 *count = inarr.count;
 for (i= 0; i < inarr.count;i++)
   i_data[i] = inarr.data[i];

#ifdef ML8RT
 asm popf
#endif
}

void EXPORT m045_set_read_pointer(byte microslot, byte channel)
{
 byte 	 	 inarr = 0;
 func_14_in_type outarr;

#ifndef ML8RT                      /* ml8x_call_func parameters */
 ushort outsize = 0,
	insize  = 0;
 byte 	err	= 0;
#else
 unsigned int outsize = 0,
	      insize  = 0,
	      err     = 0;

 asm pushf                         /* Disable CPU-Interrupt */
 asm cli
#endif

 outsize                          = sizeof(outarr);
 outarr.microslot 		  = microslot;
 outarr.channel   		  = channel;

#ifndef ML8RT
 ml8_call_func(tasknum,M045_SET_READ_POINTER_PROC,
	       outsize,&outarr,insize,&insize,&inarr,&err);
#else
 ml8rt_call_func(tasknum,M045_SET_READ_POINTER_PROC,
		 &outsize,&outarr,insize,&insize,&inarr,&err);
 asm popf;
#endif
}

void EXPORT m045_write_data(byte microslot, byte channel, ushort count, byte *o_data)
{
 byte 	 	 inarr = 0;
 ushort		 i     = 0;
 func_13_in_type outarr;

#ifndef ML8RT                      /* ml8x_call_func parameters */
 ushort outsize = 0,
	insize  = 0;
 byte 	err	= 0;
#else
 unsigned int outsize = 0,
	      insize  = 0,
	      err     = 0;

 asm pushf                         /* Disable CPU-Interrupt */
 asm cli
#endif

 outsize                          = sizeof(outarr);
 outarr.microslot 		  = microslot;
 outarr.channel   		  = channel;
 outarr.count			  = count;
 outarr.offset			  = 0;
 for (i= 0; i < count;i++) {
   outarr.data[i] = o_data[i];
   }
#ifndef ML8RT
 ml8_call_func(tasknum,M045_WRITE_DATA_PROC,
	       outsize,&outarr,insize,&insize,&inarr,&err);
#else
 ml8rt_call_func(tasknum,M045_WRITE_DATA_PROC,
		 &outsize,&outarr,insize,&insize,&inarr,&err);
 asm popf;
#endif
}

void EXPORT m045_write_data_direct(byte microslot, byte channel, ushort count, byte *o_data, byte offset)
{
 byte 	 	 inarr = 0;
 ushort		 i     = 0;
 func_13_in_type outarr;

#ifndef ML8RT                      /* ml8x_call_func parameters */
 ushort outsize = 0,
	insize  = 0;
 byte 	err	= 0;
#else
 unsigned int outsize = 0,
	      insize  = 0,
	      err     = 0;

 asm pushf                         /* Disable CPU-Interrupt */
 asm cli
#endif

 outsize                          = sizeof(outarr);
 outarr.microslot 		  = microslot;
 outarr.channel   		  = channel;
 outarr.count			  = count;
 outarr.offset			  = offset;
 for (i= 0; i < count;i++) {
   outarr.data[i] = o_data[i];
   }
#ifndef ML8RT
 ml8_call_func(tasknum,M045_WRITE_DATA_DIRECT_PROC,
	       outsize,&outarr,insize,&insize,&inarr,&err);
#else
 ml8rt_call_func(tasknum,M045_WRITE_DATA_DIRECT_PROC,
		 &outsize,&outarr,insize,&insize,&inarr,&err);
 asm popf;
#endif
}

void EXPORT m045_get_write_pointer(byte microslot, byte channel)
{
 byte 	 	 inarr = 0;
 func_14_in_type outarr;

#ifndef ML8RT                      /* ml8x_call_func parameters */
 ushort outsize = 0,
	insize  = 0;
 byte 	err	= 0;
#else
 unsigned int outsize = 0,
	      insize  = 0,
	      err     = 0;

 asm pushf                         /* Disable CPU-Interrupt */
 asm cli
#endif

 outsize                          = sizeof(outarr);
 outarr.microslot 		  = microslot;
 outarr.channel   		  = channel;

#ifndef ML8RT
 ml8_call_func(tasknum,M045_GET_WRITE_POINTER_PROC,
	       outsize,&outarr,insize,&insize,&inarr,&err);
#else
 ml8rt_call_func(tasknum,M045_GET_WRITE_POINTER_PROC,
		 &outsize,&outarr,insize,&insize,&inarr,&err);
 asm popf;
#endif
}


void EXPORT m045_start_spc3(byte microslot, byte channel)
{
 byte 	 	 inarr = 0;
 func_14_in_type outarr;

#ifndef ML8RT                      /* ml8x_call_func parameters */
 ushort outsize = 0,
	insize  = 0;
 byte 	err	= 0;
#else
 unsigned int outsize = 0,
	      insize  = 0,
	      err     = 0;

 asm pushf                         /* Disable CPU-Interrupt */
 asm cli
#endif

 outsize                          = sizeof(outarr);
 outarr.microslot 		  = microslot;
 outarr.channel   		  = channel;

#ifndef ML8RT
 ml8_call_func(tasknum,M045_START_SPC3_PROC,
	       outsize,&outarr,insize,&insize,&inarr,&err);
#else
 ml8rt_call_func(tasknum,M045_START_SPC3_PROC,
		 &outsize,&outarr,insize,&insize,&inarr,&err);
 asm popf;
#endif
}

void EXPORT m045_retrigger_user_wd(byte microslot, byte channel)
{
 byte 		 inarr = 0;
 func_15_in_type outarr;

#ifndef ML8RT                      /* ml8x_call_func parameters */
 ushort outsize = 0,
	insize  = 0;
 byte 	err	= 0;
#else
 unsigned int outsize = 0,
	      insize  = 0,
	      err     = 0;

 asm pushf                         /* Disable CPU-Interrupt */
 asm cli
#endif

 outsize                          = sizeof(outarr);
 outarr.microslot 		  = microslot;
 outarr.channel   		  = channel;

#ifndef ML8RT
 ml8_call_func(tasknum,M045_RETRIGGER_WD_PROC,
	       outsize,&outarr,insize,&insize,&inarr,&err);
#else
 ml8rt_call_func(tasknum,M045_RETRIGGER_WD_PROC,
		 &outsize,&outarr,insize,&insize,&inarr,&err);
 asm popf;
#endif
}

void EXPORT m045_get_status(byte microslot, byte channel,
		      byte *user_wd_state, byte *user_dps_state)
{
 func_16_in_type  outarr;
 func_16_out_type inarr;

#ifndef ML8RT                      /* ml8x_call_func parameters */
 ushort outsize = 0,
	insize  = 0;
 byte 	err	= 0;
#else
 unsigned int outsize = 0,
	      insize  = 0,
	      err     = 0;

 asm pushf                         /* Disable CPU-Interrupt */
 asm cli
#endif

 outsize                          = sizeof(outarr);
 insize				  = sizeof(inarr);
 outarr.microslot 		  = microslot;
 outarr.channel   		  = channel;
#ifdef ML8RT
 ml8rt_call_func(tasknum,M045_GET_STATUS_PROC,
		 &outsize,&outarr,insize,&insize,&inarr,&err);
#else
 ml8_call_func(tasknum,M045_GET_STATUS_PROC,
	       outsize,&outarr,insize,&insize,&inarr,&err);
#endif
 *user_wd_state  = inarr.user_wd_state;  /* info: the actual WD State        */
 *user_dps_state = inarr.user_dps_state; /* info: the act. PROFIBUS DP State */
#ifdef ML8RT
 asm popf
#endif
}

#pragma argsused

void EXPORT m045_data_in_out(byte microslot, byte channel)
{
  /* User definable code */

}

void EXPORT m045_write_diag(byte microslot, byte channel, byte *diag_flag,
			    byte diag_service, byte diaglen,
			    diag_data_blk *diagnose)
{
 ushort		  i = 0;
 func_19_in_type  outarr;
 func_19_out_type inarr;

#ifndef ML8RT                      /* ml8x_call_func parameters */
 ushort outsize = 0,
 insize  = 0;
 byte 	err	= 0;
#else
 unsigned int outsize = 0,
	      insize  = 0,
	      err     = 0;

 asm pushf                         /* Disable CPU-Interrupt */
 asm cli
#endif

 outsize                          = sizeof(outarr);
 insize				                = sizeof(inarr);
 outarr.microslot 		  = microslot;
 outarr.channel   		  = channel;
 outarr.diaglen			  = diaglen;
 outarr.diag_service		  = diag_service;
 for (i= 0; i < diaglen;i++) {
   outarr.diagnose.ext_diag[i] = diagnose->ext_diag[i];
   }

#ifndef ML8RT
 ml8_call_func(tasknum,M045_WRITE_DIAG_PROC,
	       outsize,&outarr,insize,&insize,&inarr,&err);
 *diag_flag = inarr.diag_flag;
#else
 ml8rt_call_func(tasknum,M045_WRITE_DIAG_PROC,
		 &outsize,&outarr,insize,&insize,&inarr,&err);
 *diag_flag = inarr.diag_flag;
 asm popf
#endif
}

#ifndef BORLAND_PASCAL
#include "m045_use.c"
#endif