/***************************************************************************/
/**                                                                       **/
/**              MODULAR-4 library for SPB module M-DPS-12                **/
/**                                                                       **/
/**                             Version 1.B. (19.01.1998)                 **/
/**                                                                       **/
/**  Changes: The address of m045_data_in_out may be defined in           **/
/**           m045_bib_startup                                            **/
/**                             Version 1.A.                              **/
/**                                                                       **/
/**  This file contains routines for Borland C++/3.1 to allow the user,   **/
/**  to write programs for the MODULAR-4 in "C"                           **/
/**                                                                       **/
/**             Project start    : 15.05.1996                             **/
/**             Last change      : 16.01.1997                             **/
/**                                                                       **/
/**                         Author : H.K.                                 **/
/**                         Status : O.K.                                 **/
/**                                                                       **/
/**     Changes beginning at 03.06.1996 by H.K. 			  **/
/**             ended     at 16.01.1997 				  **/
/**                                                                       **/
/** This library was tested with Borland C++ Version 3.1.                 **/
/**                                                                       **/
/**                                                                       **/
/**               (c) SORCUS Computer GmbH 1996                           **/
/**                                                                       **/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/

/* The switches for the library are set in the configuration files of Pascal
   (*.TP file) und C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
   to be included.
*/

/***************************************************************************/
/*                              DEFINES                                    */
/***************************************************************************/

#define ushort 		    unsigned short
#define byte                unsigned char

#define TRUE                1
#define FALSE               0

#ifdef _Windows
  #define EXPORT	_export far pascal
  #define PFAR		far pascal
#elif UNIX
  #define EXPORT
  #define PFAR
#else
  #define EXPORT	far pascal
  #define PFAR		far pascal
#endif

				   /* Benachrichtigungs-Gruende        */
				   /* (IR-Register)                    */
#define OFFLINE		    0x0001 /* Offline-Zustand; DPS2, FDL       */
#define GO_LEAVE_DATA_EX    0x0002 /* Verlassen v. DataExcahnge; DPS2  */
#define BAUDRATE_DETECT     0x0004 /* Baudrate gefunden; DPS2, FDL     */
#define WD_TIMEOUT  	    0x0008 /* DP-Watchdog abgelaufen; DPS2     */
#define USER_TIMER_CLOCK    0x0010 /* Timer-Intervall; DPS2, FDL       */
#define DDB_SCORE_ERROR     0x0020 /* irrelevant                       */
#define NEW_DDB_PRM_DATA    0x0040 /* irrelevant                       */
#define DDB_OUT             0x0080 /* irrelevant                       */
#define NEW_GC_COMMAND      0x0100 /* Global Control; DPS2             */
#define NEW_SSA_DATA        0x0200 /* Set Slave Address; DPS2          */
#define NEW_CFG_DATA        0x0400 /* Config Data; DPS2                */
#define NEW_PRM_DATA        0x0800 /* Param. Data; DPS2                */
#define DIAG_BUFFER_CHANGED 0x1000 /* Diagnose-Puffer getauscht; DPS2  */
#define DATA_IN_OUT         0x2000 /* Prozess-Ausgangsdaten; DPS2      */
#define POLL_END_IND        0x4000 /* Poll-Intervall-Ende; FDL         */
#define REQ_PDU_IND         0x8000 /* Indication eingetroffen; FDL     */


/* Gren mssen noch angepat werden */

#define MAX_CFG_LEN      244    /* 244 Number of configuration bytes */
#define MAX_DIAG_LEN	    244    /* 244 Length of diagnosis */
#define MAX_PRM_LEN	    244    /* 244 Length of parameters */
#define MAX_IN_DATA	    244	   /* 244 Max. length of input data */
#define MAX_OUT_DATA	    244	   /* 244 Max. length of output data */
#define END_OF_SPC3_RAM	    0x5FF  /* Endaddress of SPC3 RAM */

#define EXT_DIAG            0x01   /* Diagnosis flags */
#define STAT_DIAG      	    0x02
#define EXT_DIAG_OVF   	    0x04

				   /* Global control commands */
#define CLEAR_DATA          0x02
#define UNFREEZE            0x04
#define FREEZE              0x08
#define UNSYNC              0x10
#define SYNC           	    0x20

#define DIS_START_CONTROL   0x0001 /* HW-Modes */
#define DIS_STOP_CONTROL    0x0002
#define EN_FDL_DDB          0x0004
#define ENABLE_DEF_MINTSDR  0x0008
#define INT_POL_LOW         0x0000
#define INT_POL_HIGH        0x0010
#define EARLY_RDY           0x0020
#define SYNC_SUPPORTED      0x0040
#define FREEZE_SUPPORTED    0x0080
#define DP_MODE             0x0100
#define EOI_TIMEBASE_1u     0x0000
#define EOI_TIMEBASE_1m     0x0200
#define USER_TIMEBASE_1m    0x0000
#define USER_TIMEBASE_10m   0x0400
#define SPEC_PRM_BUF        0x1000
#define SPEC_CLEAR          0x2000

#define DPS_CFG_OK          0      /* Configuration flags */
#define DPS_CFG_FAULT       1
#define DPS_CFG_UPDATE      2

#define DPS_PRM_OK          0      /* Parameter flags */
#define DPS_PRM_CONFLICT    1
#define DPS_PRM_NOT_ALLOWED 3

#define IO_LENGTH_ERROR     20


#define M045_TASK            	     3 //2
#define M045_BIB_START_PROC 	    10
#define M045_INIT_PROC 		    11
#define M045_READ_DATA_AVAIL_PROC   12
#define M045_READ_DATA_DIRECT_PROC  20
#define M045_SET_READ_POINTER_PROC  23
#define M045_WRITE_DATA_PROC        13
#define M045_WRITE_DATA_DIRECT_PROC 21
#define M045_GET_WRITE_POINTER_PROC 22
#define M045_START_SPC3_PROC   	    14
#define M045_RETRIGGER_WD_PROC      15
#define M045_GET_STATUS_PROC   	    16
#define M045_READ_DATA_PROC    	    17
#define M045_GET_DIAG_PAR_PROC 	    18
#define M045_WRITE_DIAG_PROC   	    19

/* Structures used in library */
/* Structure of diagnosis data */


typedef struct
  {
   byte stationstatus_1;           /* Predefined diagnosis header */
   byte stationstatus_2;
   byte stationstatus_3;
   byte master_add;
   byte ident_high;
   byte ident_low;

  /*------------------ extern diag data  -----------------*/
   byte header;
   byte ext_diag[18];
  } diag_data_blk;

typedef struct
  {
   ushort din_dout_buf_len;        /* length of I/O-databuffers 0-488  */
   byte diag_buf_len;              /* length of diagnosisbuffer 6-244  */
   byte prm_buf_len;               /* length of parameterbuffer 7-244  */
   byte cfg_buf_len;               /* length of config-databuf. 1-244  */
   byte ssa_buf_len;               /* length of set-slave-addr.-buf.   */
				   /*  0 / 4-244                       */
  } DPS2_BUFINIT;

typedef struct {
	 byte   microslot;
	 byte 	channel;
	 void EXPORT (*m045_diag_buffer_changed) (byte microslot,
						  byte channel);
	 byte EXPORT (*m045_check_parameter) (byte microslot, byte channel,
					      byte *prm_parameter,
					      byte param_data_len,
					      byte prm_result);
	 byte EXPORT (*m045_check_config) (byte microslot, byte channel,
					   byte *cfg_parameter,
					   byte cfg_data_len,
					   byte cfg_result);
	 void EXPORT (*m045_offline) (byte microslot, byte channel);
	 void EXPORT (*m045_global_ctrl_command) (byte microslot,
						  byte channel,
						  byte user_global_ctrl_command);
	 void EXPORT (*m045_go_leave_data_ex) (byte microslot, byte channel,
					       byte user_dps_state);
	 void EXPORT (*m045_wd_timeout) (byte microslot, byte channel,
					 byte user_wd_state);
	 void EXPORT (*m045_new_ssa_data) (byte microslot, byte channel,
					   byte this_station,
					   byte real_no_add_chg);
	 void EXPORT (*m045_user_timer_clock) (byte microslot, byte channel);
	 void EXPORT (*m045_baudrate_detect) (byte microslot, byte channel, byte baudrate);
	 void EXPORT (*m045_error_function) (byte microslot, byte channel,
					     short error);
	 void EXPORT (*m045_data_in_out) (byte microslot, byte channel);
	 } func_10_in_type;


 typedef struct {
	 ushort       indication;  /* Indication */
	 ushort       user_wd_val; /* User-watchdog-timeout value */
	 byte         this_station;/* Station number */
	 ushort       ident_num;   /* PNO-Number */
	 byte         change_station_number; /* Change of station number possible ? */
	 ushort       hw_mode;     /* HW-mode */
	 byte         mintsdr;     /* Minimal Default delay after reset */
	 DPS2_BUFINIT dps2_buf;    /* SPC3-Buffer lengths */
	 byte         cfg_akt[MAX_CFG_LEN];     /* I/O-configuration */
	 byte         cfg_len_akt; /* Number of configuration bytes */
	 byte	      *i_data; 	   /* Adresspointer of input data area */
	 } m_dps_12_type;

 typedef struct {
	 byte         microslot;
	 byte 	      channel;
	 byte 	      irq_num;
	 m_dps_12_type m_dps_12;
	 } func_11_in_type;

 typedef struct {
	 byte   microslot;
	 byte 	channel;
	 byte 	offset;
	 } func_12_in_type;

 typedef struct {
	 byte   flag;
	 ushort count;
	 byte	data[MAX_IN_DATA];
	} func_12_out_type;

 typedef struct {
	 byte   microslot;
	 byte 	channel;
	 ushort	count;
	 byte	offset;
	 byte	data[MAX_OUT_DATA];
	 } func_13_in_type;

 typedef struct {
	 byte   microslot;
	 byte 	channel;
	 } func_14_in_type;

 typedef struct {
	 byte   microslot;
	 byte 	channel;
	 } func_15_in_type;

 typedef struct {
	 byte   microslot;
	 byte 	channel;
	 } func_16_in_type;

 typedef struct {
	 byte   user_wd_state;
	 byte 	user_dps_state;
	} func_16_out_type;

 typedef struct {
	 byte   microslot;
	 byte 	channel;
	 } func_17_in_type;

 typedef struct {
	 ushort	count;
	 byte	data[MAX_IN_DATA];
	} func_17_out_type;

 typedef struct {
	 byte   microslot;
	 byte 	channel;
	 byte	diag_len;
	 } func_18_in_type;

 typedef struct {
	 byte	diaglen;
	} func_18_out_type;

 typedef struct {
	 byte   	  microslot;
	 byte 		  channel;
	 byte		  diaglen;
	 byte		  diag_service;
	 diag_data_blk    diagnose;         /* Pointer to diagnosis */
	 } func_19_in_type;

 typedef struct {
	 byte		  diag_flag;
	} func_19_out_type;

void far pascal errorhandler(void);

/***************************************************************************/
/*             Prototypes of functions and procedures                      */
/***************************************************************************/

/* Initialize library and M-DPS-12 Task
*/
void EXPORT m045_bib_startup(byte microslot, byte channel);

/* Initialize SPC3 via M-DPS-12 Task
*/
void EXPORT m045_init(byte 	    microslot,
		      byte 	    channel,
		      byte   	    irq_num,
		      m_dps_12_type m_dps_12);

/* Start SPC3 via M-DPS-12 Task
*/
void EXPORT m045_start_spc3(byte microslot, byte channel);

/* Check and Read Data from SPC3 via M-DPS-12 Task
*/
void EXPORT m045_read_data (byte microslot, byte channel, ushort *count, byte *flag,
			    byte *i_data);

/* Read Data direct from SPC3 via M-DPS-12 Task
*/
void EXPORT m045_read_data_direct (byte microslot, byte channel, ushort *count,
			    byte *i_data, byte offset);

/* Set Read-Pointer via M-DPS-12 Task
*/
void EXPORT m045_set_read_pointer(byte microslot, byte channel);

/* Write Data to SPC3 via M-DPS-12 Task
*/
void EXPORT m045_write_data(byte microslot, byte channel, ushort count, byte *o_data);

/* Write Data to SPC3 via M-DPS-12 Task
*/
void EXPORT m045_write_data_direct (byte microslot, byte channel, ushort count, byte *o_data, byte offset);

/* Get Write-Pointer via M-DPS-12 Task
*/
void EXPORT m045_get_write_pointer(byte microslot, byte channel);

/* Get status from SPC3 via M-DPS-12 Task
*/
void EXPORT m045_get_status(byte microslot, byte channel,
			    byte *user_wd_state, byte *user_dps_state);

/* Retrigger User-Watchdog via M-DPS-12 Task
*/
void EXPORT m045_retrigger_user_wd(byte microslot, byte channel);

/* Read Data from SPC3 (called by ISR and m045_read_data) via M-DPS-12 Task
*/
void EXPORT m045_data_in_out(byte microslot, byte channel);

/* Write diagnosis data
*/
void EXPORT m045_write_diag(byte microslot, byte channel, byte *diag_flag,
			    byte diag_service, byte diag_len, diag_data_blk *diagnose);

/*
  User definable functions, called by interrupt service routine,
  available only on-board the MODULAR-4/486
*/

/* Diagnosis data changed
*/

#ifdef BORLAND_PASCAL
void extern EXPORT m045_diag_buffer_changed(byte microslot, byte channel);
#else
void EXPORT m045_diag_buffer_changed(byte microslot, byte channel);
#endif

/* Check parameter
*/
#ifdef BORLAND_PASCAL
byte extern EXPORT m045_check_parameter(byte microslot, byte channel, byte *prm_parameter,
				 byte param_data_len, byte prm_result);
#else
byte EXPORT m045_check_parameter(byte microslot, byte channel, byte *prm_parameter,
				 byte param_data_len, byte prm_result);
#endif

/* Check configuration
*/
#ifdef BORLAND_PASCAL
byte extern EXPORT m045_check_config(byte microslot, byte channel, byte *cfg_parameter,
			      byte cfg_data_len, byte cfg_result);
#else
byte EXPORT m045_check_config(byte microslot, byte channel, byte *cfg_parameter,
			      byte cfg_data_len, byte cfg_result);
#endif

/* Reset function
*/
#ifdef BORLAND_PASCAL
void extern EXPORT m045_offline(byte microslot, byte channel);
#else
void EXPORT m045_offline(byte microslot, byte channel);
#endif

/* Global control function
*/
#ifdef BORLAND_PASCAL
void extern EXPORT m045_global_ctrl_command(byte microslot, byte channel,
				     byte user_global_ctrl_command);
#else
void EXPORT m045_global_ctrl_command(byte microslot, byte channel,
				     byte user_global_ctrl_command);
#endif

/* Go/leave data exchange status
*/
#ifdef BORLAND_PASCAL
void extern EXPORT m045_go_leave_data_ex(byte microslot, byte channel,
				  byte user_dps_state);
#else
void EXPORT m045_go_leave_data_ex(byte microslot, byte channel,
				  byte user_dps_state);
#endif

/* Watchdog timeout
*/
#ifdef BORLAND_PASCAL
void extern EXPORT m045_wd_timeout(byte microslot, byte channel,
				    byte user_wd_state);
#else
void EXPORT m045_wd_timeout(byte microslot, byte channel,
				    byte user_wd_state);
#endif

/* Station address changed
*/
#ifdef BORLAND_PASCAL
void extern EXPORT m045_new_ssa_data(byte microslot, byte channel,
			      byte this_station, byte change_station_number);
#else
void EXPORT m045_new_ssa_data(byte microslot, byte channel,
			      byte this_station, byte change_station_number);
#endif

/* User timer clock
*/
#ifdef BORLAND_PASCAL
void extern EXPORT m045_user_timer_clock(byte microslot, byte channel);
#else
void EXPORT m045_user_timer_clock(byte microslot, byte channel);
#endif

/* Baudrate found
*/
#ifdef BORLAND_PASCAL
void extern EXPORT m045_baudrate_detect(byte microslot, byte channel, byte baudrate);
#else
void EXPORT m045_baudrate_detect(byte microslot, byte channel, byte baudrate);
#endif

/* Error function
*/
#ifdef BORLAND_PASCAL
void extern EXPORT m045_error_function(byte microslot, byte channel, short error);
#else
void EXPORT m045_error_function(byte microslot, byte channel, short error);
#endif

