/* Wenn Daten direct aus dem SPC3 gelesen oder in den SPC3 geschrieben
   werden sollen mu
   #define DIRECT
   angegeben werden
*/
#define DIRECT
/***************************************************************************/
/**                             Version 1.B.                              **/
/**                                                                       **/
/**                        last change : 09.01.98                         **/
/**                                                                       **/
/**                             Version 1.A.                              **/
/**                                                                       **/
/**                               date : 04.04.97                         **/
/**                        last change : 04.04.97                         **/
/**                             status : released                         **/
/**                             author : H.K.                             **/
/**                                                                       **/
/**                                                                       **/
/**                (c) 1997 SORCUS Computer GmbH Heidelberg               **/
/**                                                                       **/
/***************************************************************************/
#include "dos.h"
#include "stdlib.h"
#include "ml8rtbib.h"                     /* header of real-time-library   */

					  /* general defines               */
#define PROGRAM_NUMBER  0x332             /* program-number = 332h         */
#define VERSION         '1'               /* program-version               */
#define REVISION        'A'               /* program-revision              */

#define EXPORT far pascal
#define USER_WD_VAL             20000
#define IDENT_HI                0x00
#define IDENT_LO                0x00
#define INDICATION		GO_LEAVE_DATA_EX | WD_TIMEOUT |\
				NEW_GC_COMMAND   | NEW_SSA_DATA       |\
				NEW_CFG_DATA     | NEW_PRM_DATA       |\
				DATA_IN_OUT | DIAG_BUFFER_CHANGED

//|\USER_TIMER_CLOCK

#define CHANGE_STATION_NUMBER   TRUE
#define HW_MODE                 SYNC_SUPPORTED   | FREEZE_SUPPORTED |\
				INT_POL_LOW	 | USER_TIMEBASE_10m | EOI_TIMEBASE_1m

#define TSDRMIN                 11

const unsigned short channels[2] = {0x00, 0x08};
const unsigned short micro_slot_basis[11] = {0, 0x400, 0x500, 0x600,
                                                0x700, 0x420, 0x440,
                                                0x460, 0x480, 0x4A0,
                                                0x4c0};

#define CHANNEL                    channels[channel]      /* Channels 0..1                    */
#define MBA                        micro_slot_basis[microslot]
#define mlx_out8_port(port, dat1)  outportb(port, dat1)
#define mlx_out16_port(port, dat1) outport(port, dat1)
#define mlx_in8_port(port)         inportb(port)
#define mlx_in16_port(port)        inport(port)

#include "m045_lib.h"
#include "m8p0332.h"

					  /* Programm-Descriptor-Tab.(PDT) */
struct pdt_type
{
 unsigned char    typ;                    /* type of PDT                   */
 unsigned char    lengt;                  /* length of PDT-header          */
 unsigned int     proc_num;               /* number of procedures          */
 unsigned int     prg_number;             /* program-number                */
 unsigned char    version;                /* program-version               */
 unsigned char    revision;               /* program-revision              */

 unsigned char    cpu_type;               /* processor-type                */
 unsigned char    coproz_type;            /* co-prozessor-type             */
 unsigned char    language;               /* programming language          */
 unsigned char    prg_type;               /* program-type                  */

 unsigned int     flags;                  /* installation-flags            */
 unsigned int     interrupt_num;          /* number of the used interrupt  */

 unsigned long    data_adr;               /* start-address of data-range   */
 unsigned long    data_size;              /* size of data-range            */
 unsigned long    data_min;               /* minimum size of data-range    */
					                           /* for this program              */
 unsigned long    data_max;               /* maximum size of data-range    */
					                           /* for the program               */

 unsigned long    parameter_adr;          /* address of parameter-range    */
 unsigned int     parameter_size;         /* number of parameters          */

 unsigned long    hyper_adr;              /* start-addr.of hypertext-range */
 unsigned int     res1;
 unsigned long    res2;

 void             (*main_proc)();         /* address of Main-proc.(Task)   */
 void             (*auto_init)();         /* address of Auto-Init-proced.  */
 void             (*start)();             /* address of Start-procedure    */
 void             (*stop)();              /* address of Stop-procedure     */
 void		  (*read_data)();	  /* address of read-data proc.    */
 void		  (*write_data)();	  /* address of write-data proc.   */
 void		  (*write_diag)();	  /* address of read-diag proc.    */
 void		  (*write_data_pointer)();/* address of write-data_pointer proc.   */
 void		  (*read_data_pointer)(); /* address of read-data_pointer proc.   */
} pdt;

					  /* parameter-area definition    */
struct parameter_type
{
 tdt_type          tdt;                    /* Size of Task-Descriptor-Table*/
 unsigned char	   microslot;		   /* Slot-no. of M-DPS-12 	   */
 unsigned char	   channel;                /* Channel-no. on M-DPS-12 	   */
 unsigned char     irq_num;                /* IRQ-number 		   */
 ushort            indication;             /* Indication			   */
 unsigned char     this_station;           /* Station-Address		   */
 unsigned char     real_no_add_chg; 	   /* Address can be changed or not */
 unsigned char     cfg_len;		   /* Length of configuration area  */
 unsigned char     cfg_akt[16];            /* Configuration area		   */
 ushort		   iodatalen;		   /* number of iodata              */
 unsigned char     iodata[20];             /* iodata of iobuffer            */
 unsigned char	   dps_chg_diag_srvc_byte_new;  /* New diagnosis?	   */
 unsigned char	   user_diag_flag[2];	   /* Flag			   */
 unsigned char	   dps_service; 	   /* Service flag		   */
 unsigned char	   diaglen;		   /* Length of diagnosis data	   */
 unsigned char	   flag;		   /* Additional flag 		   */
 } parameter;


 byte	           user_diag_flag[2];
 diag_data_blk     diagnose;
 byte              i_data[488];
 byte              o_data[488];
 byte              k;
 m_dps_12_type     m_dps_12;


 byte p = 0x5C;

 ushort  baudflag, cfgflag, prmflag;

void auto_init(void);                     /* prototypes of the procedures  */
void start(void);
void stop(void);
void main_task(void);
void init_pdt(void);


/* procedures :                  */

void auto_init(void)                      /* AUTO-INIT                     */
{
 ml8rt_entry();                           /* save & prepare registers      */
 ml8rt_local_led_off();                   /* switch off on-board LED       */
 ml8rt_exit();                            /* rebuild registers             */
};


void start(void)                          /* START-PROCEDURE               */
{
 ushort i;

 ml8rt_entry();

 m_dps_12.dps2_buf.din_dout_buf_len = 244;
 m_dps_12.dps2_buf.diag_buf_len     = sizeof(diag_data_blk);
 m_dps_12.dps2_buf.prm_buf_len      = 20;
 m_dps_12.dps2_buf.cfg_buf_len      = 16;
 m_dps_12.dps2_buf.ssa_buf_len      = 5;       /* reserve buffer if address
                                                  change is possible */

 for(i = 0; i < 4; i++) {                      /* Init of Output-Data */
   o_data[i] = o_data[i] + (3 * (i+1));
   }

 m_dps_12.indication   = parameter.indication;
 m_dps_12.user_wd_val  = USER_WD_VAL;
 m_dps_12.this_station = parameter.this_station;
 m_dps_12.ident_num    = ((ushort)(IDENT_HI) << 8) | IDENT_LO;
 m_dps_12.change_station_number = parameter.real_no_add_chg;
 m_dps_12.hw_mode      = HW_MODE;
 m_dps_12.mintsdr      = TSDRMIN;
 m_dps_12.cfg_akt[0]   = parameter.cfg_akt[0];
 m_dps_12.cfg_akt[1]   = parameter.cfg_akt[1];
 m_dps_12.cfg_len_akt  = parameter.cfg_len;
 m_dps_12.i_data       = i_data;

 m045_bib_startup(parameter.microslot,parameter.channel);
 m045_init(parameter.microslot, parameter.channel, 0x1, m_dps_12);
 m045_start_spc3(parameter.microslot, parameter.channel);
 if (parameter.channel == 0) {
   m045_init(parameter.microslot, parameter.channel+1, 0x1, m_dps_12);
   m045_start_spc3(parameter.microslot, parameter.channel+1);
 }
 ml8rt_exit();
}

void stop(void)                           /* STOP-PROCEDURE                */
{
 ml8rt_entry();
 ml8rt_exit();
}

/* Write Data direct to Profi-Bus */

void write_data(void)
{
 ml8rt_entry();
 m045_retrigger_user_wd(parameter.microslot, parameter.channel);                           /* Reset User-Watchdog */
 for (k=0;k<parameter.iodatalen;k++) {
   o_data [k] = parameter.iodata[k];
 }
#ifdef DIRECT
  m045_write_data_direct(parameter.microslot,parameter.channel,parameter.iodatalen-2,o_data,2);
#else
 m045_write_data(parameter.microslot,parameter.channel,parameter.iodatalen,o_data);
#endif
 if (parameter.channel == 0) {
   m045_retrigger_user_wd(parameter.microslot, parameter.channel+1);                           /* Reset User-Watchdog */
#ifdef DIRECT
   m045_write_data_direct(parameter.microslot,parameter.channel+1,parameter.iodatalen,o_data,0);
#else
   m045_write_data(parameter.microslot,parameter.channel+1,parameter.iodatalen,o_data);
#endif
   }
 ml8rt_exit();
}

/* Get new write-pointer
*/
void write_data_pointer(void)
{
 ml8rt_entry();
#ifdef DIRECT
 m045_get_write_pointer(parameter.microslot,parameter.channel);
 if (parameter.channel == 0)
   m045_get_write_pointer(parameter.microslot,parameter.channel+1);
#endif
 ml8rt_exit();
}

/* Set new Read-pointer
*/
void read_data_pointer(void)
{
 ml8rt_entry();
#ifdef DIRECT
 m045_set_read_pointer(parameter.microslot,parameter.channel);
#endif
 ml8rt_exit();
}
/* Read Data direct from Profi-Bus */

void read_data(void)
{
 ushort len;
 byte flag;
#ifdef DIRECT
 byte offset;
#endif

 ml8rt_entry();
#ifdef DIRECT
 offset = 0;
 len = parameter.iodatalen;
 m045_read_data_direct(parameter.microslot,parameter.channel,
		       &len,i_data,offset);
 for (k=0;k<parameter.iodatalen;k++) {
   parameter.iodata[k+parameter.iodatalen] = i_data[k];
   }
#else
 m045_read_data(parameter.microslot,parameter.channel,
		       &len,&flag,i_data);
 if (flag == 0x20) {
 for (k=0;k<parameter.iodatalen;k++) {
   parameter.iodata[k+parameter.iodatalen] = i_data[k];
   }
   parameter.flag = flag;
 }
#endif
 ml8rt_exit();
}

/* Write diagnosis data */

void write_diag(void)
{
 byte i;
 ml8rt_entry();
 diagnose.ext_diag[0] = parameter.diaglen;
 user_diag_flag[parameter.channel] = parameter.user_diag_flag[parameter.channel];
 m045_write_diag(parameter.microslot, parameter.channel, &user_diag_flag[parameter.channel],
				 parameter.dps_service, parameter.diaglen, &diagnose);
 parameter.user_diag_flag[parameter.channel] = user_diag_flag[parameter.channel];
 if (parameter.diaglen == 12) {
   for (i=1;i<parameter.diaglen;i++)
     diagnose.ext_diag[i] = diagnose.ext_diag[i] + 2;
 }
					  /* possible  				   */
 ml8rt_exit();
}

void main_task(void)                      /* MAIN-PROCEDURE OF THE TASK    */
{
  ushort i;
  byte wd_state,dps_state;

  ml8rt_entry();
  ml8rt_exit();
}

void init_pdt()                           /* PDT-INIT                      */
{
 pdt.typ = 1;                             /* set PDT-type (only type 1 is  */
					                           /* supported at the moment)      */
 pdt.lengt      = _PDT_LENGTH;            /* length of PDT-header          */
					                           /* (at the moment always = 48)   */
 pdt.proc_num   = 5+4;                      /* number of procedures          */
 pdt.prg_number = PROGRAM_NUMBER;         /* program-number                */
 pdt.version    = VERSION;                /* program-version               */
 pdt.revision   = REVISION;               /* program-revision              */
 pdt.cpu_type   = _486DX;                 /* CPU-type                      */
 pdt.coproz_type = _487DX;                /* Co-processor-type             */
 pdt.language   = _CPP31;                 /* programming language = C++    */
 pdt.prg_type   = _USER_PRG;              /* program-type: user-program    */
 pdt.flags      = 0;                      /* flags                         */
 pdt.flags      = _NI_TASK +
		  _PDT_INFO_ENABLE +
		  _LOCAL_DATA +
		  _LOCAL_PARAMETER +
		  _FIXED_DATASIZE;
 pdt.interrupt_num = 0;                   /* interrupt-number for this prg.*/
					                           /*                               */

 pdt.data_adr   = 0;                      /* address of data-area         */
 					                           /* (not used here)              */
 pdt.data_size  = 0;                      /* size of data-area            */
 pdt.data_min   = 0;                      /* minimum size of data-area    */
 pdt.data_max   = 0;                      /* maximum size of data-area    */
					                           /* calculate                    */
					                           /* address of parameter-area    */
					  /* calculate                     */
					  /* address of parameter-range    */
 ml8rt_phys_adr(&parameter, &pdt.parameter_adr);
 pdt.parameter_adr  = pdt.parameter_adr + sizeof(tdt_type);
					  /* set number of parameters      */
 pdt.parameter_size = sizeof(parameter) - sizeof(tdt_type);
 pdt.hyper_adr = 0;                       /* addr. of hypertext (not used) */

 pdt.main_proc = *main_task;              /* addr. of main-procedure       */
 pdt.auto_init = *auto_init;              /* addr. of Auto-Init-proc.      */
 pdt.start     = *start;                  /* addr. of Start-procedure      */
 pdt.stop      = *stop;                   /* addr. of Stop-procedure       */
 pdt.write_data= *write_data;  		  /* addr. of write-data-proc. 	   */
 pdt.read_data = *read_data;  		  /* addr. of read-data-proc. 	   */
 pdt.write_diag = *write_diag;  		  /* addr. of write-diag-proc. 	   */
 pdt.write_data_pointer= *write_data_pointer; /* addr. of write-data-pointer-proc. */
 pdt.read_data_pointer= *read_data_pointer;   /* addr. of read-data-poiner-proc.   */
}


void main()                               /* PREPARE                       */
{
 init_pdt();                              /* initialize PDT                */
 ml8rt_set_pdt_adr(&pdt);                 /* operating system needs the    */
					                           /* address of the PDT            */
}
