/***************************************************************************/
/* (C) 1997      SORCUS Computer GmbH Heidelberg  06221/3206-0             */
/***************************************************************************/
/*                                                                         */
/* Programmname  : M-DPS-12.H                                              */
/*                                                                         */
/* Projektname   : M-DPS-12                                                */
/*                                                                         */
/* Funktion      : Headerdatei des Hauptprogramms fuer M-DPS-12.EXE        */
/*                                                                         */
/* Compiler      : Borland C++ 3.1                                         */
/*                                                                         */
/* Programmierer : Alexander Horst  / H.K.  04.04.1997                     */
/*                                                                         */
/* Version/Datum : 1.0 / 11.03.1996 / 04.04.1997                           */
/*                                                                         */
/* Revision      : Version  Datum     Autor     Bemerkungen                */
/*                 -------  --------  --------  -------------------------- */
/*                 1.0      11.03.96  A. Horst  Start                      */
/*                                                                         */
/* Status        : nicht freigegeben                                       */
/*                                                                         */
/***************************************************************************/

#define byte   unsigned char
#define ushort unsigned short


/***************************************************************************/
/******************************** Structures *******************************/
/***************************************************************************/

/*--------------------- Commands for Mode-Register 1 ----------------------*/
  #define START_SPC3          0x01
  #define EOI_SPC3            0x02
  #define GO_OFFLINE_SPC3     0x04
  #define USER_LEAVE_MASTER   0x08
  #define EN_CHG_CFG_BUFFER   0x10
  #define RES_USER_WD         0x20

/*-------------------- Commands for Status-Register 0 ---------------------*/
  #define SPC3_OFFLINE_PASS   0x01
  #define FDL_IND_ST          0x02
  #define DPS2_DIAG_FLAG      0x04
  #define ACCESS_VIOLATION    0x08

/*-------------------- Commands for diagnosis control ---------------------*/
  #define DPS2_EXT_DIAG       0x01
  #define DPS2_STAT_DIAG      0x02
  #define DPS2_EXT_DIAG_OVF   0x04

/*------------------ Equates for global control commands ------------------*/
  #define DPS2_CLEAR_DATA     0x02
  #define DPS2_UNFREEZE       0x04
  #define DPS2_FREEZE         0x08
  #define DPS2_UNSYNC         0x10
  #define DPS2_SYNC           0x20


#define MAC_RESET_B             0x01 /* Offline-status; DPS2, FDL */
#define GO_LEAVE_DATA_EX_B      0x02 /* Leave DataExchange mode; DPS2 */
#define BAUDRATE_DETECT_B       0x04 /* Baudrate found; DPS2, FDL */
#define WD_DP_MODE_TIMEOUT_B    0x08 /* DP-Watchdog timeout; DPS2 */
#define USER_TIMER_CLOCK_B      0x10 /* Timer-interval; DPS2, FDL */
#define DDB_SCORE_ERROR_B       0x20 /* irrelevant */
#define NEW_DDB_PRM_DATA_B      0x40 /* irrelevant */
#define DDB_OUT_B               0x80 /* irrelevant */
#define NEW_GC_COMMAND_B        0x01 /* Global Control; DPS2 */
#define NEW_SSA_DATA_B          0x02 /* Set Slave Address; DPS2 */
#define NEW_CFG_DATA_B          0x04 /* Config Data; DPS2 */
#define NEW_PRM_DATA_B          0x08 /* Param. Data; DPS2 */
#define DIAG_BUFFER_CHANGED_B   0x10 /* Diagnose-Puffer changed; DPS2 */
#define DX_OUT_B                0x20 /* Process-output-data; DPS2 */
#define POLL_END_IND_B          0x40 /* Poll-interval-end; FDL */
#define REQ_PDU_IND_B           0x80 /* Indication occurred; FDL */



