{$C MOVEABLE DEMANDLOAD DISCARDABLE}
(***************************************************************************)
(**                                                                       **)
(**              MODULAR-4 library for SPB module M-DPS-12                **)
(**                                                                       **)
(**                             Version 1.A.                              **)
(**                                                                       **)
(**  This file contains routines for Borland C++/3.1 to allow the user,   **)
(**  to write programs for the MODULAR-4 in "Pascal"                      **)
(**                                                                       **)
(**  Changes: 4 functions added: m045_read_data_direct	20		  **)
(**                              m045_write_data_direct	21		  **)
(**                              m045_set_read_pointer	23		  **)
(**                              m045_get_write_pointer	22		  **)
(**                                                                       **)
(**             Last change      : 03.04.1997                             **)
(**                                                                       **)
(**                         Author : H.K.                                 **)
(**                         Status : O.K.                                 **)
(**                                                                       **)
(**                                                                       **)
(** This library was tested with Borland Pascal Version 7.0               **)
(**                                                                       **)
(**               (c) SORCUS Computer GmbH 1996                           **)
(**                                                                       **)
(***************************************************************************)
(***************************************************************************)
(***************************************************************************)

(* The switches for the library are set in the configuration files of Pascal
   (*.TP file) und C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
   to be included.
*)

(***************************************************************************)
(*                              DEFINES                                    *)
(***************************************************************************)
unit m045_lib;
interface
uses
    {$IFDEF Windows}
            wml8bib;        (* Include library for MODULAR-4/486 under Windows *)
    {$ELSE}
           {$IFDEF ML8RT}
                   ml8rtbib;    (* Include library for MODULAR-4/486 realtime programs *)
           {$ELSE}
                   ml8bib;      (* Include library for MODULAR-4/486 under DOS *)
           {$ENDIF}
    {$ENDIF}

{$IFDEF Windows}
const
     M045DLL = 'M045_LIB';
{$ENDIF}
				   (* Benachrichtigungs-Gruende        *)
				   (* (IR-Register)                    *)
CONST OFFLINE		  = $0001; (* Offline-Zustand; DPS2, FDL       *)
      GO_LEAVE_DATA_EX    = $0002; (* Verlassen v. DataExcahnge; DPS2  *)
      BAUDRATE_DETECT     = $0004; (* Baudrate gefunden; DPS2, FDL     *)
      WD_TIMEOUT  	  = $0008; (* DP-Watchdog abgelaufen; DPS2     *)
      USER_TIMER_CLOCK    = $0010; (* Timer-Intervall; DPS2, FDL       *)
      DDB_SCORE_ERROR     = $0020; (* irrelevant                       *)
      NEW_DDB_PRM_DATA    = $0040; (* irrelevant                       *)
      DDB_OUT             = $0080; (* irrelevant                       *)
      NEW_GC_COMMAND      = $0100; (* Global Control; DPS2             *)
      NEW_SSA_DATA        = $0200; (* Set Slave Address; DPS2          *)
      NEW_CFG_DATA        = $0400; (* Config Data; DPS2                *)
      NEW_PRM_DATA        = $0800; (* Param. Data; DPS2                *)
      DIAG_BUFFER_CHANGED = $1000; (* Diagnose-Puffer getauscht; DPS2  *)
      DATA_IN_OUT         = $2000; (* Prozess-Ausgangsdaten; DPS2      *)
      POLL_END_IND        = $4000; (* Poll-Intervall-Ende; FDL         *)
      REQ_PDU_IND         = $8000; (* Indication eingetroffen; FDL     *)


(* Gren mssen noch angepat werden *)

      MAX_CFG_LEN         = 2;     (* 244 Number of configuration bytes *)
      MAX_DIAG_LEN	  = 6;     (* 244 Length of diagnosis *)
      MAX_PRM_LEN	  = 244;   (* 244 Length of parameters *)
      MAX_IN_DATA	  = 244;   (* 244 Max. length of input data *)
      MAX_OUT_DATA	  = 244;   (* 244 Max. length of output data *)
      END_OF_SPC3_RAM	  = $5FF;  (* Endaddress of SPC3 RAM *)

      EXT_DIAG            = $01;   (* Diagnosis flags *)
      STAT_DIAG      	  = $02;
      EXT_DIAG_OVF   	  = $04;

				         (* Global control commands *)
      CLEAR_DATA          = $02;
      UNFREEZE            = $04;
      FREEZE              = $08;
      UNSYNC              = $10;
      SYNC           	  = $20;

      DIS_START_CONTROL   = $0001; (* HW-Modes *)
      DIS_STOP_CONTROL    = $0002;
      EN_FDL_DDB          = $0004;
      ENABLE_DEF_MINTSDR  = $0008;
      INT_POL_LOW         = $0000;
      INT_POL_HIGH        = $0010;
      EARLY_RDY           = $0020;
      SYNC_SUPPORTED      = $0040;
      FREEZE_SUPPORTED    = $0080;
      DP_MODE             = $0100;
      EOI_TIMEBASE_1u     = $0000;
      EOI_TIMEBASE_1m     = $0200;
      USER_TIMEBASE_1m    = $0000;
      USER_TIMEBASE_10m   = $0400;
      SPEC_PRM_BUF        = $1000;
      SPEC_CLEAR          = $2000;

      DPS_CFG_OK          = 0;      (* Configuration flags *)
      DPS_CFG_FAULT       = 1;
      DPS_CFG_UPDATE      = 2;

      DPS_PRM_OK          = 0;      (* Parameter flags *)
      DPS_PRM_CONFLICT    = 1;
      DPS_PRM_NOT_ALLOWED = 3;

      IO_LENGTH_ERROR     = 20;


      M045_TASK                 = 2;
      M045_BIB_START_PROC       = 10;
      M045_INIT_PROC 	        = 11;
      M045_READ_DATA_AVAIL_PROC = 12;
      M045_WRITE_DATA_PROC      = 13;
      M045_START_SPC3_PROC   	= 14;
      M045_RETRIGGER_WD_PROC    = 15;
      M045_GET_STATUS_PROC   	= 16;
      M045_READ_DATA_PROC    	= 17;
      M045_GET_DIAG_PAR_PROC 	= 18;
      (*M045_WRITE_DIAG_PROC   	= 19;*)
      M045_READ_DATA_DIRECT_PROC     = 20;
      M045_WRITE_DATA_DIRECT_PROC    = 21;
      M045_SET_READ_POINTER_PROC     = 23;
      M045_GET_WRITE_POINTER_PROC    = 22;

      tasknum: word = M045_TASK;

TYPE
    DPS2_BUFINIT = record
                   din_dout_buf_len: word; (* length of I/O-databuffers 0-488  *)
                   diag_buf_len: byte;     (* length of diagnosisbuffer 6-244  *)
                   prm_buf_len: byte;      (* length of parameterbuffer 7-244  *)
                   cfg_buf_len: byte;      (* length of config-databuf. 1-244  *)
                   ssa_buf_len: byte;      (* length of set-slave-addr.-buf.   *)
				           (*  0 / 4-244                       *)
                   end;



    m_dps_12_par = record
                indication: word;                       (* Indication *)
	        user_wd_val: word;                      (* User-watchdog-timeout value *)
	        this_station: byte;                     (* Station number *)
	        ident_num: word;                        (* PNO-Number *)
	        change_station_number: byte;            (* Change of station number possible ? *)
	        hw_mode: word;                          (* HW-mode *)
	        mintsdr: byte;                          (* Minimal Default delay after reset *)
	        dps2_buf: DPS2_BUFINIT;                 (* SPC3-Buffer lengths *)
	        cfg_akt: array[1..MAX_CFG_LEN] of byte; (* I/O-configuration *)
	        cfg_len_akt: byte;                      (* Number of configuration bytes *)
	        i_data: ^byte; 	                        (* Adresspointer of input data area *)
	        end;

    diag_data_blk = record                              (* Structure of diagnosis data *)
                    stationstatus_1: byte;              (* Predefined diagnosis header *)
                    stationstatus_2: byte;
                    stationstatus_3: byte;
                    master_add: byte;
                    ident_high: byte;
                    ident_low: byte;
    (*------------------ extern diag data  -----------------*)
                    header: byte;
                    ext_diag: array [1..18] of byte;
                    end;

(***************************************************************************)
(*             Prototypes of Funktions and Procedures                      *)
(***************************************************************************)

(* Initialize library and M-DPS-12 Task
*)
procedure m045_bib_startup(microslot, channel: byte);

(* Initialize SPC3 via M-DPS-12 Task
*)
procedure m045_init(microslot, channel, irq_num: byte;
		    m_dps_12: m_dps_12_par);

(* Start SPC3 via M-DPS-12 Task
*)
procedure m045_start_spc3(microslot, channel: byte);

(* Check and Read Data from SPC3 via M-DPS-12 Task
*)
procedure m045_read_data (microslot, channel: byte; var count: word; var flag: byte; var i_data);

(* Read Data direct from SPC3 via M-DPS-12 Task
*)
procedure m045_read_data_direct (microslot, channel: byte; var count: word;
			    var i_data; offset: byte);

(* Set Read-Pointer via M-DPS-12 Task
*)
procedure m045_set_read_pointer(microslot, channel: byte);

(* Write Data to SPC3 via M-DPS-12 Task
*)
procedure m045_write_data(microslot, channel: byte; count: word; var o_data);

(* Write Data to SPC3 via M-DPS-12 Task
*)
procedure m045_write_data_direct (microslot, channel: byte; count: word; var o_data; offset: byte);

(* Get Write-Pointer via M-DPS-12 Task
*)
procedure m045_get_write_pointer(microslot, channel: byte);

(* Get status from SPC3 via M-DPS-12 Task
*)
procedure m045_get_status(microslot, channel: byte; var user_wd_state,
                          user_dps_state: byte);

(* Reset User-Watchdog via M-DPS-12 Task
*)
procedure m045_retrigger_user_wd(microslot, channel: byte);

(* Read Data from SPC3 (called by ISR and m045_read_data) via M-DPS-12 Task
*)
procedure m045_data_in_out(microslot, channel: byte; var count: word;
                           var i_data);

(*
  User definable functions, called by Interrupt-Service-Routine,
  available only on-board the MODULAR-4/486
*)


(* Diagnosis data changed
*)
procedure m045_diag_buffer_changed(microslot, channel: byte);

(* Write diagnosis data
*)
procedure m045_write_diag(microslot, channel: byte; var diag_flag: byte;
			  diag_service, diag_len: byte; var diagnose: diag_data_blk);

(* Check parameter
*)
function m045_check_parameter(microslot, channel: byte; var prm_parameter: byte;
                              param_data_len, prm_result: byte): byte;

(* Check configuration
*)
function m045_check_config(microslot, channel: byte; var cfg_parameter: byte;
			   cfg_data_len, cfg_result: byte): byte;

(* Reset function
*)
procedure m045_offline(microslot, channel: byte);

(* Global control function
*)
procedure m045_global_ctrl_command(microslot, channel,
                                   user_global_ctrl_command: byte);

(* Go/leave data exchange status
*)
procedure m045_go_leave_data_ex(microslot, channel, user_dps_state: byte);

(* Write new diagnosis data
*)
procedure m045_wd_timeout(microslot, channel, user_wd_state: byte);

(* Station address changed
*)
procedure m045_new_ssa_data(microslot, channel,
			    this_station, change_station_number: byte);

(* User timer clock
*)
procedure m045_user_timer_clock(microslot, channel: byte);

(* Baudrate lost
*)
procedure m045_baudrate_detect(microslot, channel, baudrate: byte);

(* Error function
*)
procedure m045_error_function(microslot, channel: byte; error: integer);

implementation

{$IFNDEF Windows}           (* If no DLL is generated, a .OBj file has to be included *)

{$L m045_lib.obj}

{$ENDIF}

(* Initialize library and M-DPS-12 Task
*)
procedure m045_bib_startup(microslot, channel: byte);
          external {$IFDEF Windows} M045DLL {$ENDIF};

(* Initialize SPC3 via M-DPS-12 Task
*)
procedure m045_init(microslot, channel, irq_num: byte;
		    m_dps_12: m_dps_12_par);
          external {$IFDEF Windows} M045DLL {$ENDIF};

(* Start SPC3 via M-DPS-12 Task
*)
procedure m045_start_spc3(microslot, channel: byte);
          external {$IFDEF Windows} M045DLL {$ENDIF};

(* Check and Read Data from SPC3 via M-DPS-12 Task
*)
procedure m045_read_data (microslot, channel: byte; var count: word;
                          var flag: byte; var i_data);
          external {$IFDEF Windows} M045DLL {$ENDIF};

(* Read Data direct from SPC3 via M-DPS-12 Task
*)
procedure m045_read_data_direct (microslot, channel: byte; var count: word;
			    var i_data; offset: byte);
          external {$IFDEF Windows} M045DLL {$ENDIF};

(* Set Read-Pointer via M-DPS-12 Task
*)
procedure m045_set_read_pointer(microslot, channel: byte);
          external {$IFDEF Windows} M045DLL {$ENDIF};

(* Write Data to SPC3 via M-DPS-12 Task
*)
procedure m045_write_data(microslot, channel: byte; count: word; var o_data);
          external {$IFDEF Windows} M045DLL {$ENDIF};

(* Write Data to SPC3 via M-DPS-12 Task
*)
procedure m045_write_data_direct (microslot, channel: byte; count: word; var o_data; offset: byte);
          external {$IFDEF Windows} M045DLL {$ENDIF};

(* Get Write-Pointer via M-DPS-12 Task
*)
procedure m045_get_write_pointer(microslot, channel: byte);
          external {$IFDEF Windows} M045DLL {$ENDIF};

(* Get status from SPC3 via M-DPS-12 Task
*)
procedure m045_get_status(microslot, channel: byte; var user_wd_state,
                          user_dps_state: byte);
          external {$IFDEF Windows} M045DLL {$ENDIF};

(* Reset User-Watchdog via M-DPS-12 Task
*)
procedure m045_retrigger_user_wd(microslot, channel: byte);
          external {$IFDEF Windows} M045DLL {$ENDIF};

(* Read Data from SPC3 (called by ISR and m045_read_data) via M-DPS-12 Task
*)
procedure m045_data_in_out(microslot, channel: byte; var count: word;
                           var i_data);
          external {$IFDEF Windows} M045DLL {$ENDIF};

(* Write diagnosis data
*)
procedure m045_write_diag(microslot, channel: byte; var diag_flag: byte;
			  diag_service, diag_len: byte; var diagnose: diag_data_blk);
          external {$IFDEF Windows} M045DLL {$ENDIF};

{$I M045_USE.PAS}

begin
end.